## darknet 0.0.0+git20180914.61c9d02e

=== Makefile ===
GPU=0
CUDNN=0
OPENCV=0
OPENMP=0
DEBUG=0

ARCH= -gencode arch=compute_30,code=sm_30 \
      -gencode arch=compute_35,code=sm_35 \
      -gencode arch=compute_50,code=[sm_50,compute_50] \
      -gencode arch=compute_52,code=[sm_52,compute_52]
#      -gencode arch=compute_20,code=[sm_20,sm_21] \ This one is deprecated?

# This is what I use, uncomment if you know your arch and want to specify
# ARCH= -gencode arch=compute_52,code=compute_52

VPATH=./src/:./examples
SLIB=libdarknet.so
ALIB=libdarknet.a
EXEC=darknet
OBJDIR=./obj/

CC=gcc
CPP=g++
NVCC=nvcc 
AR=ar
ARFLAGS=rcs
OPTS=-Ofast
LDFLAGS= -lm -pthread 
COMMON= -Iinclude/ -Isrc/
CFLAGS=-Wall -Wno-unused-result -Wno-unknown-pragmas -Wfatal-errors -fPIC

ifeq ($(OPENMP), 1) 
CFLAGS+= -fopenmp
endif

ifeq ($(DEBUG), 1) 
OPTS=-O0 -g
endif

CFLAGS+=$(OPTS)

ifeq ($(OPENCV), 1) 
COMMON+= -DOPENCV
CFLAGS+= -DOPENCV
LDFLAGS+= `pkg-config --libs opencv` -lstdc++
COMMON+= `pkg-config --cflags opencv` 
endif

ifeq ($(GPU), 1) 
COMMON+= -DGPU -I/usr/local/cuda/include/
CFLAGS+= -DGPU
LDFLAGS+= -L/usr/local/cuda/lib64 -lcuda -lcudart -lcublas -lcurand
endif

ifeq ($(CUDNN), 1) 
COMMON+= -DCUDNN 
CFLAGS+= -DCUDNN
LDFLAGS+= -lcudnn
endif

OBJ=gemm.o utils.o cuda.o deconvolutional_layer.o convolutional_layer.o list.o image.o activations.o im2col.o col2im.o blas.o crop_layer.o dropout_layer.o maxpool_layer.o softmax_layer.o data.o matrix.o network.o connected_layer.o cost_layer.o parser.o option_list.o detection_layer.o route_layer.o upsample_layer.o box.o normalization_layer.o avgpool_layer.o layer.o local_layer.o shortcut_layer.o logistic_layer.o activation_layer.o rnn_layer.o gru_layer.o crnn_layer.o demo.o batchnorm_layer.o region_layer.o reorg_layer.o tree.o  lstm_layer.o l2norm_layer.o yolo_layer.o iseg_layer.o image_opencv.o
EXECOBJA=captcha.o lsd.o super.o art.o tag.o cifar.o go.o rnn.o segmenter.o regressor.o classifier.o coco.o yolo.o detector.o nightmare.o instance-segmenter.o darknet.o
ifeq ($(GPU), 1) 
LDFLAGS+= -lstdc++ 
OBJ+=convolutional_kernels.o deconvolutional_kernels.o activation_kernels.o im2col_kernels.o col2im_kernels.o blas_kernels.o crop_layer_kernels.o dropout_layer_kernels.o maxpool_layer_kernels.o avgpool_layer_kernels.o
endif

EXECOBJ = $(addprefix $(OBJDIR), $(EXECOBJA))
OBJS = $(addprefix $(OBJDIR), $(OBJ))
DEPS = $(wildcard src/*.h) Makefile include/darknet.h

all: obj backup results $(SLIB) $(ALIB) $(EXEC)
#all: obj  results $(SLIB) $(ALIB) $(EXEC)


$(EXEC): $(EXECOBJ) $(ALIB)
	$(CC) $(COMMON) $(CFLAGS) $^ -o $@ $(LDFLAGS) $(ALIB)

$(ALIB): $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

$(SLIB): $(OBJS)
	$(CC) $(CFLAGS) -shared $^ -o $@ $(LDFLAGS)

$(OBJDIR)%.o: %.cpp $(DEPS)
	$(CPP) $(COMMON) $(CFLAGS) -c $< -o $@

$(OBJDIR)%.o: %.c $(DEPS)
	$(CC) $(COMMON) $(CFLAGS) -c $< -o $@

$(OBJDIR)%.o: %.cu $(DEPS)
	$(NVCC) $(ARCH) $(COMMON) --compiler-options "$(CFLAGS)" -c $< -o $@

obj:
	mkdir -p obj
backup:
	mkdir -p backup
results:
	mkdir -p results

.PHONY: clean

clean:
	rm -rf $(OBJS) $(SLIB) $(ALIB) $(EXEC) $(EXECOBJ) $(OBJDIR)/*

## darknet 0.0.0%2Bgit20180914.61c9d02e

=== debian/control ===
Source: darknet
Section: science
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: debhelper (>= 11),
               docbook-xsl,
               libopencv-dev,
               pkg-config,
               python3,
               xsltproc
Standards-Version: 4.2.1
Homepage: https://pjreddie.com/darknet/

Package: darknet
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Open Source Neural Networks in C
 Darknet is an open source neural network framework written in C and CUDA.
 It is fast, easy to install, and supports CPU and GPU computation.

## darknet 0.0.0+git20180914.61c9d02e

=== debian/changelog ===
darknet (0.0.0+git20180914.61c9d02e-3) unstable; urgency=low

  * Add 0006-port-to-python3.13.patch (Closes: #1084609)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 05 Dec 2024 21:45:54 +0800

darknet (0.0.0+git20180914.61c9d02e-2) unstable; urgency=low

  * Port to OpenCV4. Fix FTBFS on OpenCV4. (Closes: #922573)
    - 0003-Fix-compilation-with-latest-OpenCV.patch
    - 0004-Enable-C-11-for-OpenCV-4.patch
    - 0005-Fix-1421-use-after-free.patch
    - These patch comes from https://github.com/tiagoshibata/darknet
    - pull request - https://github.com/pjreddie/darknet/pull/1348

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 28 Oct 2019 03:23:14 +0800

darknet (0.0.0+git20180914.61c9d02e-1) unstable; urgency=low

  * Initial release (Closes: #913851)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 20 Nov 2018 14:05:08 +0800

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
 Build-Depends: debhelper (>= 11),
                docbook-xsl,
-               libopencv-dev,
-               pkg-config,
+               libopencv-dev (>= 4),
+               pkgconf,
                python3,
                xsltproc
 Standards-Version: 4.2.1
